11.20.10   os32: proc_scheduler(9)

NOME

    proc_scheduler - schedulatore

SINTASSI

    <kernel/proc.h>
    extern uint32_t <_ksp>;
    extern uint32_t <proc_stack_pointer>;
    extern uint16_t <proc_stack_segment_selector>;
    extern pid_t    <proc_current>;
    void proc_scheduler (void);

ARGOMENTI

    Argomento                                      Descrizione
    extern uint32_t <_ksp>;                        La variabile <_ksp> contiene
                                                   l'indice della pila del
                                                   kernel.
                                                   La variabile
                                                   <proc_stack_pointer> contiene
    extern uint32_t <proc_stack_pointer>;          l'indice della pila del
                                                   processo interrotto, dal
                                                   punto di vista del segmento
                                                   dati del processo stesso.
                                                   La variabile
    extern uint16_t <proc_stack_segment_selector>; <proc_stack_segment_selector>
                                                   contiene il valore del
                                                   registro <SS> (stack segment)
                                                   relativo al processo sospeso.
                                                   La variabile <proc_current>
    extern pid_t <proc_current>;                   contiene il numero del
                                                   processo corrente, appena
                                                   sospeso.

DESCRIZIONE

    La funzione <proc_scheduler()> viene avviata a seguito di un'interruzione
    hardware, dovuta al temporizzatore, oppure a seguito di un'interruzione
    software, dovuta a una chiamata di sistema.

    La prima cosa che fa la funzione consiste nel verificare che il valore
    dell'indice della pila del processo interrotto non superi lo spazio
    disponibile per la pila stessa. Diversamente il processo viene eliminato
    forzatamente, con una segnalazione adeguata sul terminale attivo. Si
    ottiene comunque una segnalazione se l'indice si avvicina pericolosamente
    al limite.

    Successivamente la funzione svolge delle operazioni che riguardano tutti i
    processi: aggiorna i contatori dei processi che attendono lo scadere di un
    certo tempo; verifica la presenza di segnali e predispone le azioni
    relative; raccoglie l'input dai terminali. Quindi aggiorna il tempo di
    utilizzo della CPU del processo appena interrotto.

    Poi inizia la ricerca di un altro processo, candidato a essere ripreso al
    posto di quello interrotto. La ricerca inizia dal processo successivo a
    quello interrotto, senza considerare alcun criterio di precedenza. Il ciclo
    termina se la ricerca incontra di nuovo il processo di partenza.
    All'interno di questo ciclo di ricerca, se si incontra un processo pronto
    per essere messo in funzione, lo si scambia con quello interrotto: in
    pratica si salva il valore attuale dell'indice della pila, si scambiano gli
    stati e si aggiornano i valori di <proc_current>,
    <proc_stack_segment_selector> e <proc_stack_pointer>, in modo da ottenere
    effettivamente lo scambio all'uscita dalla funzione. Alla fine del ciclo,
    occorre verificare se esiste effettivamente un processo successivo
    attivato, perche' in caso contrario, si lascia il controllo direttamente al
    kernel. In fine, si salva il valore accumulato in precedenza dell'indice
    della pila del kernel, nella variabile <_ksp>.

    Questa funzione viene usata dalla routine irq_timer del file kernel/
    ibm_i386/isr.s e dalla funzione sysroutine(9) [11.20.28].

FILE SORGENTI

    kernel/proc.h [12.14]

    kernel/ibm_i386/isr.s [12.6.21]

    kernel/proc/sysroutine.c [12.14.28]

    kernel/proc/proc_scheduler.c [12.14.11]

VEDERE ANCHE

    proc_sch_timers(9) [11.20.9], proc_sch_signals(9) [11.20.7],
    proc_sch_terminals(9) [11.20.8].

